    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------
    028     * EmptyBlock.java
    029     * ---------------
    030     * (C) Copyright 2004, 2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: EmptyBlock.java,v 1.4.2.1 2005/10/25 20:39:38 mungady Exp $
    036     *
    037     * Changes:
    038     * --------
    039     * 22-Oct-2004 : Version 1 (DG);
    040     * 04-Feb-2005 : Now cloneable and serializable (DG);
    041     * 20-Apr-2005 : Added new draw() method (DG);
    042     *
    043     */
    044
    045    package org.jfree.chart.block;
    046
    047    import java.awt.Graphics2D;
    048    import java.awt.geom.Rectangle2D;
    049    import java.io.Serializable;
    050
    051    import org.jfree.util.PublicCloneable;
    052
    053    /**
    054     * An empty block with a fixed size.
    055     */
    056    public class EmptyBlock extends AbstractBlock
    057                            implements Block, Cloneable, PublicCloneable,
    058                                       Serializable {
    059
    060        /** For serialization. */
    061        private static final long serialVersionUID = -4083197869412648579L;
    062
    063        /**
    064         * Creates a new block with the specified width and height.
    065         *
    066         * @param width  the width.
    067         * @param height  the height.
    068         */
    069        public EmptyBlock(double width, double height) {
    070            setWidth(width);
    071            setHeight(height);
    072        }
    073
    074        /**
    075         * Draws the block.  Since the block is empty, this method does nothing.
    076         *
    077         * @param g2  the graphics device.
    078         * @param area  the area.
    079         */
    080        public void draw(Graphics2D g2, Rectangle2D area) {
    081            // do nothing, we're empty
    082        }
    083
    084        /**
    085         * Draws the block within the specified area.  Since the block is empty,
    086         * this method does nothing.
    087         *
    088         * @param g2  the graphics device.
    089         * @param area  the area.
    090         * @param params  ignored (<code>null</code> permitted).
    091         *
    092         * @return Always <code>null</code>.
    093         */
    094        public Object draw(Graphics2D g2, Rectangle2D area, Object params) {
    095            return null;
    096        }
    097
    098        /**
    099         * Returns a clone of the block.
    100         *
    101         * @return A clone.
    102         *
    103         * @throws CloneNotSupportedException if there is a problem cloning.
    104         */
    105        public Object clone() throws CloneNotSupportedException {
    106            return super.clone();
    107        }
    108
    109    }